package com.huimv.production.autoGetData.service.impl;

import antlr.StringUtils;
import cn.hutool.core.date.DateTime;
import cn.hutool.core.date.DateUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
//import com.huimv.common.date.DateUtil;
import com.huimv.production.autoGetData.entity.*;
import com.huimv.production.autoGetData.repo.*;
import com.huimv.production.autoGetData.service.IAutoGetErpData;
import com.huimv.production.autoGetData.utils.HttpTemplete;
import com.huimv.production.autoGetData.utils.MathUtil;
import lombok.extern.slf4j.Slf4j;
import org.apache.tomcat.jni.Time;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.data.domain.Example;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;

import java.io.IOException;
import java.math.BigDecimal;
import java.sql.Timestamp;
import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.text.ParseException;
import java.util.*;

import static org.apache.tomcat.jni.Time.now;
import static org.apache.tomcat.jni.Time.sleep;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
@Service
@Slf4j
public class AutoGetErpDataImpl implements IAutoGetErpData {
    // 查询开始日期
//    @Value("${erp.datasource.startDate}")
//    private String startDate;
    // 查询结束日期
//    @Value("${erp.datasource.endDate}")
//    private String endDate;
    @Value("${erp.datasource.apiIp}")
    private String apiIp;
    @Value("${erp.datasource.apiPort}")
    private String apiPort;
    @Value("${erp.datasource.serviceName}")
    private String serviceName;
    @Value("${timeout.connectTimeout}")
    private String connectTimeout;
    @Value("${timeout.requestTimeout}")
    private String requestTimeout;
    @Value("${timeout.socketTimeout}")
    private String socketTimeout;
    @Autowired
    private HttpTemplete httpClientUtil;
    @Autowired
    private RestTemplate template;
    /*  @Autowired
      private IndexParameterRepository parameterRepository;
      @Autowired
      private ProductionGroupRepo productionGroupRepo;*/
    @Autowired
    private com.huimv.production.autoGetData.utils.DateUtil dateUtil;
    @Autowired
    private ProdWarningMsgRepo warningMsgRepo;
    @Autowired
    private ProdFarmNameRepo prodFarmNameRepo;
    @Autowired
    private ProdStockRepo prodStockRepo;
    @Autowired
    private MathUtil mathUtil;
    @Autowired
    private ProdWorkPlanRepo workPlanRepo;
    @Autowired
    private ProdImportantIndicatorRepo prodImportantIndicatorRepo;
    @Autowired
    private ProdIndicatorDynamicRepo prodIndicatorDynamicRepo;

    /* //PSY
     @Override
     public void getPsy() {
         String token = getToken();
 //        String servicePath = apiIp + apiPort + serviceName;
 //        System.out.println("servicePath>>"+servicePath);
         String startDate;
         String endDate;
         DateTime date = DateUtil.date();
         endDate = (date + "").substring(0, 10);
         startDate = (DateUtil.beginOfMonth(date) + "").substring(0, 10);

         JSONObject jsonObject = template.getForObject(apiIp + apiPort + serviceName + "/getPsy?startDate=" + startDate + "&endDate=" + endDate + "&accessToken=" + token
                 , JSONObject.class);
         String data = jsonObject.getString("data");
         System.out.println("data>>"+data);
         if (data == null) {
             return;
         }
         IndexParameter indexParameter = parameterRepository.findById(7).get();
         indexParameter.setUpdateTime(new Date());
         indexParameter.setData(data);
         System.out.println("PSY------->" + data);

         parameterRepository.save(indexParameter);


         System.out.println("startDate:" + startDate);
         System.out.println("endDate:" + endDate);
     }

     //返情率
     @Override
     public void getReEstrusRate() {
         String startDate;
         String endDate;
         DateTime date = DateUtil.date();
         endDate = (date + "").substring(0, 10);
         startDate = (DateUtil.beginOfMonth(date) + "").substring(0, 10);

         String token = getToken();
         JSONObject jsonObject = template.getForObject(apiIp + apiPort + serviceName + "/getReEstrusRate?startDate=" + startDate + "&endDate=" + endDate + "&accessToken=" + token
                 , JSONObject.class);
         String data = jsonObject.getString("data");
         if (data == null) {
             return;
         }

         String reestrus_rate = "0.00000";
         String variety = "";
         ProductionGroup productionGroup = new ProductionGroup();
         int i = 4;
         List<Map<String, String>> list = (List<Map<String, String>>) JSON.parse(data);
         for (Map<String, String> stringStringMap : list) {
 //            for (String s : stringStringMap.keySet()) {
 //                String farm = stringStringMap.get(s);
             //                if (farm != null && farm.contains("秀洲")){
             reestrus_rate = stringStringMap.get("reestrus_rate");
             variety = stringStringMap.get("variety");
             productionGroup.setProductionType("reEstrus");
             productionGroup.setVariety(variety);
             productionGroup.setId(i);
             productionGroup.setFrequency(reestrus_rate);
             productionGroupRepo.save(productionGroup);
             i++;
 //                }
 //            }
         }
         System.out.println("返情率------->" + data);


     }

     //获取分娩率
     @Override
     public void getParturitionRate() {
         String startDate;
         String endDate;
         DateTime date = DateUtil.date();
         endDate = (date + "").substring(0, 10);
         startDate = (DateUtil.beginOfMonth(date) + "").substring(0, 10);

         String token = getToken();
         JSONObject jsonObject = template.getForObject(apiIp + apiPort + serviceName + "/getParturitionRate?startDate=" + startDate + "&endDate=" + endDate + "&accessToken=" + token
                 , JSONObject.class);
         String data = jsonObject.getString("data");
         if (data == null) {
             return;
         }

         String parturitionRate = "0.00000";
         String variety = "";
         ProductionGroup productionGroup = new ProductionGroup();
         int i = 1;
         List<Map<String, String>> list = (List<Map<String, String>>) JSON.parse(data);
         for (Map<String, String> stringStringMap : list) {
 //            for (String s : stringStringMap.keySet()) {
 //                String farm = stringStringMap.get(s);
             //                if (farm != null && farm.contains("秀洲")){
             parturitionRate = stringStringMap.get("parturition_rate");
             variety = stringStringMap.get("variety");
             productionGroup.setFrequency(parturitionRate);
             productionGroup.setId(i);
             productionGroup.setProductionType("parturition");
             productionGroup.setVariety(variety);
             productionGroupRepo.save(productionGroup);
             i++;
 //                }
 //            }
         }

         System.out.println("分娩率--->" + data);

     }

     //获取各种存栏
     @Override
     public List getStorage() {


         String token = getToken();
         JSONObject jsonObject = template.getForObject(apiIp + apiPort + serviceName + "/getStorage?accessToken=" + token
                 , JSONObject.class);
         String data = jsonObject.getString("data");
         if (data == null) {
             return null;
         }
         List<Map<String, String>> list = (List<Map<String, String>>) JSON.parse(data);
         JSON.parse(data);
         List list1 = new ArrayList();
         for (Map<String, String> stringStringMap : list) {
             for (String s : stringStringMap.keySet()) {
                 String farm = stringStringMap.get(s);
                 //                if (farm != null && farm.contains("秀洲")){
                 Map map = new HashMap();
                 map.put("name", stringStringMap.get("name"));
                 map.put("quantity", stringStringMap.get("quantity"));
                 list1.add(map);
 //                }
             }
         }
         System.out.println("各种存栏--->" + data);
         return list1;
     }

     //获取均产仔数，仔猪存活率
     @Override
     public void getPigletInfo() {
         String startDate;
         String endDate;
         DateTime date = DateUtil.date();
         endDate = (date + "").substring(0, 10);
         startDate = (DateUtil.beginOfMonth(date) + "").substring(0, 10);

         String token = getToken();
         JSONObject jsonObject = template.getForObject(apiIp + apiPort + serviceName + "/getPigletInfo?startDate=" + startDate + "&endDate=" + endDate + "&accessToken=" + token
                 , JSONObject.class);
         String data = jsonObject.getString("data");
         if (data == null) {
             return;
         }
         //TODO 未完成
         System.out.println("均产仔数，仔猪存活率--->" + data);
         String birth_number = "0";
         String total = "0";
         String dead_quantity = "0";
         List<Map<String, String>> list = (List<Map<String, String>>) JSON.parse(data);
         for (Map<String, String> stringStringMap : list) {
             for (String s : stringStringMap.keySet()) {
                 String farm = stringStringMap.get(s);
                 //                if (farm != null && farm.contains("秀洲")){
                 birth_number = stringStringMap.get("birth_number");
                 total = stringStringMap.get("total");
                 dead_quantity = stringStringMap.get("dead_quantity");
 //                }
             }
         }

         //分娩头数
         IndexParameter indexParameter = parameterRepository.findById(19).get();
         indexParameter.setData(birth_number);
         indexParameter.setUpdateTime(new Date());
         parameterRepository.save(indexParameter);
         System.out.println(indexParameter);


         //产仔总数
         IndexParameter indexParameter2 = parameterRepository.findById(20).get();
         indexParameter2.setData(total);
         indexParameter2.setUpdateTime(new Date());
         parameterRepository.save(indexParameter2);

         //仔猪死淘数
         IndexParameter indexParameter3 = parameterRepository.findById(21).get();
         indexParameter3.setData(dead_quantity);
         indexParameter3.setUpdateTime(new Date());
         parameterRepository.save(indexParameter);
     }

     //配种数量
     @Override
     public void getMateQuantity() {
         String startDate;
         String endDate;
         DateTime date = DateUtil.date();
         endDate = (date + "").substring(0, 10);
         startDate = (DateUtil.beginOfMonth(date) + "").substring(0, 10);

         String token = getToken();
         JSONObject jsonObject = template.getForObject(apiIp + apiPort + serviceName + "/getMateQuantity?startDate=" + startDate + "&endDate=" + endDate + "&accessToken=" + token
                 , JSONObject.class);
         String data = jsonObject.getString("data");
         if (data == null) {
             return;
         }
         String mate_quantity = "0";
         String variety = "";
         ProductionGroup productionGroup = new ProductionGroup();
         int i = 7;
         List<Map<String, String>> list = (List<Map<String, String>>) JSON.parse(data);
         for (Map<String, String> stringStringMap : list) {
 //            for (String s : stringStringMap.keySet()) {
 //                String farm = stringStringMap.get(s);
             //                if (farm != null && farm.contains("秀洲")){
             mate_quantity = stringStringMap.get("mate_quantity");
             variety = stringStringMap.get("variety");
             productionGroup.setId(i);
             productionGroup.setFrequency(mate_quantity);
             productionGroup.setVariety(variety);
             productionGroup.setProductionType("mateQuantity");
             productionGroupRepo.save(productionGroup);
             i++;
 //                }
 //            }
         }

         System.out.println("配种数------->" + data);


     }

     //受胎率
     @Override
     public void getConceptionRate() {
         String startDate;
         String endDate;
         DateTime date = DateUtil.date();
         endDate = (date + "").substring(0, 10);
         startDate = (DateUtil.beginOfMonth(date) + "").substring(0, 10);

         String token = getToken();
         JSONObject jsonObject = template.getForObject(apiIp + apiPort + serviceName + "/getConceptionRate?startDate=" + startDate + "&endDate=" + endDate + "&accessToken=" + token
                 , JSONObject.class);
         String data = jsonObject.getString("data");
         if (data == null) {
             return;
         }
         String conception_rate = "0";
         List<Map<String, String>> list = (List<Map<String, String>>) JSON.parse(data);
         for (Map<String, String> stringStringMap : list) {
 //            for (String s : stringStringMap.keySet()) {
 //                String farm = stringStringMap.get(s);
             //                if (farm != null && farm.contains("秀洲")){
             conception_rate = stringStringMap.get("conception_rate");
 //                }
 //            }
         }
         IndexParameter indexParameter = parameterRepository.findById(18).get();
         indexParameter.setData(conception_rate);
         indexParameter.setUpdateTime(new Date());

         System.out.println("受胎率------->" + data);
         parameterRepository.save(indexParameter);
     }

     //总存栏，母猪存栏
     @Override
     public void getAllStorage() {
         String startDate;
         String endDate;
         DateTime date = DateUtil.date();
         endDate = (date + "").substring(0, 10);
         startDate = (DateUtil.beginOfMonth(date) + "").substring(0, 10);

         String token = getToken();
         JSONObject jsonObject = template.getForObject(apiIp + apiPort + serviceName + "/getAllStorage?startDate=" + startDate + "&endDate=" + endDate + "&accessToken=" + token
                 , JSONObject.class);
         String data = jsonObject.getString("data");
         if (data == null) {
             return;
         }
         List<Map<String, String>> list = (List<Map<String, String>>) JSON.parse(data);
         String total = "0";
         String sow_quantity = "0";

         for (Map<String, String> stringStringMap : list) {
             for (String s : stringStringMap.keySet()) {
                 String farm = stringStringMap.get(s);
                 //                if (farm != null && farm.contains("秀洲")){
                 total = stringStringMap.get("total");
                 sow_quantity = stringStringMap.get("sow_quantity");
 //                }
             }
         }
         IndexParameter indexParameter = parameterRepository.findById(2).get();
         indexParameter.setData(total);
         indexParameter.setUpdateTime(new Date());
         parameterRepository.save(indexParameter);

         IndexParameter indexParameter1 = parameterRepository.findById(3).get();
         indexParameter1.setData(sow_quantity);
         indexParameter1.setUpdateTime(new Date());
         System.out.println("总存栏，母猪存栏------->" + data);

         parameterRepository.save(indexParameter);
     }

     @Override
     public List findAll() {
         List<ProductionGroup> delivery = productionGroupRepo.findAllByVariety("巴嘉");
         List<ProductionGroup> reservice = productionGroupRepo.findAllByVariety("杜巴嘉");
         List<ProductionGroup> breeding = productionGroupRepo.findAllByVariety("金华两头乌");
         Map map1 = new HashMap();
         Map map2 = new HashMap();
         Map map3 = new HashMap();
         map1.put("veriety", "巴嘉");
         map2.put("veriety", "杜巴嘉");
         map3.put("veriety", "金华两头乌");
         for (ProductionGroup productionGroup : delivery) {
             map1.put(productionGroup.getProductionType(), productionGroup.getFrequency());
         }
         for (ProductionGroup productionGroup : reservice) {
             map2.put(productionGroup.getProductionType(), productionGroup.getFrequency());
         }
         for (ProductionGroup productionGroup : breeding) {
             map3.put(productionGroup.getProductionType(), productionGroup.getFrequency());
         }

         List list = new ArrayList();
         list.add(map1);
         list.add(map2);
         list.add(map3);
         return list;
     }
 */
    @Autowired
    private ProdProduceRepo produceRepo;

    @Override
    public void getManyFarmProduce() throws IOException {
        DecimalFormat df = new DecimalFormat("0.00");
        String startDate;
        String endDate;
        DateTime date = DateUtil.date();
        endDate = (date + "").substring(0, 10);
        startDate = (DateUtil.beginOfMonth(date) + "").substring(0, 10);
        String year = dateUtil.getThisYear();
        String month = dateUtil.getThisMonth();
        //
        String token = getRemoteToken();
//        JSONObject jsonObject = template.getForObject(apiIp + apiPort + serviceName +"/getManyFarmProduce?startDate="+startDate+"&endDate="+endDate+"&accessToken="+token
//                ,JSONObject.class );
//        String data = jsonObject.getString("data");
//        if (data == null){
//            return;
//        }
        Map<String, String> paramsMap = new HashMap<String, String>();
        paramsMap.put("startDate", startDate);
        paramsMap.put("endDate", endDate);
        paramsMap.put("accessToken", token);

        Map<String, Integer> timeoutMap = new HashMap<String, Integer>();
        timeoutMap.put("connectTimeout", Integer.parseInt(connectTimeout));
        timeoutMap.put("requestTimeout", Integer.parseInt(requestTimeout));
        timeoutMap.put("socketTimeout", Integer.parseInt(socketTimeout));
        String url = apiIp + apiPort + serviceName + "/getManyFarmProduce";
        log.info("多个牧场生产数据访问地址=" + url);
        log.info("业务请求参数=" + paramsMap.toString());
        log.info("超时参数=" + timeoutMap.toString());
        log.info("开始取数＝" + new Date(System.currentTimeMillis()));
        //
        JSONObject outJo = httpClientUtil.doGet(url, paramsMap, timeoutMap);
        log.info("返回结果=" + outJo);
        log.info("完成取数＝" + new Date(System.currentTimeMillis()));
        if (outJo.getBoolean("status")) {
            JSONObject contentJo = outJo.getJSONObject("content");
            if (contentJo.getBoolean("success")) {
                JSONArray dataJa = contentJo.getJSONArray("data");
                System.out.println("" + dataJa);
                if (dataJa.size() > 0) {
                    //获取牧场所有名称数据
                    List<ProdFarmNameEntity> farmNameEntityList = prodFarmNameRepo.findAll();
                    //-- 删除旧数据 --//
                    //删除产房成活率
                    ProdProduceEntity delEntity1 = new ProdProduceEntity();
                    delEntity1.setYear(Integer.parseInt(year));
                    delEntity1.setMonth(Integer.parseInt(month));
                    delEntity1.setStockType("grice_rate");
                    Example<ProdProduceEntity> example1 = Example.of(delEntity1);
                    produceRepo.deleteAll(produceRepo.findAll(example1));
                    //删除保育成活率
                    ProdProduceEntity delEntity2 = new ProdProduceEntity();
                    delEntity2.setYear(Integer.parseInt(year));
                    delEntity2.setMonth(Integer.parseInt(month));
                    delEntity2.setStockType("piglet_rate");
                    Example<ProdProduceEntity> example2 = Example.of(delEntity2);
                    produceRepo.deleteAll(produceRepo.findAll(example2));
                    //删除育肥成活率
                    ProdProduceEntity delEntity3 = new ProdProduceEntity();
                    delEntity3.setYear(Integer.parseInt(year));
                    delEntity3.setMonth(Integer.parseInt(month));
                    delEntity3.setStockType("fatpig_rate");
                    Example<ProdProduceEntity> example3 = Example.of(delEntity3);
                    produceRepo.deleteAll(produceRepo.findAll(example3));
                    //删除7日内断配率
                    ProdProduceEntity delEntity4 = new ProdProduceEntity();
                    delEntity4.setYear(Integer.parseInt(year));
                    delEntity4.setMonth(Integer.parseInt(month));
                    delEntity4.setStockType("break_rate");
                    Example<ProdProduceEntity> example4 = Example.of(delEntity4);
                    produceRepo.deleteAll(produceRepo.findAll(example4));
                    //删除平均窝产仔猪
                    ProdProduceEntity delEntity5 = new ProdProduceEntity();
                    delEntity5.setYear(Integer.parseInt(year));
                    delEntity5.setMonth(Integer.parseInt(month));
                    delEntity5.setStockType("avg_farrow_1");
                    Example<ProdProduceEntity> example5 = Example.of(delEntity5);
                    produceRepo.deleteAll(produceRepo.findAll(example5));
                    //删除平均窝产活仔数
                    ProdProduceEntity delEntity6 = new ProdProduceEntity();
                    delEntity6.setYear(Integer.parseInt(year));
                    delEntity6.setMonth(Integer.parseInt(month));
                    delEntity6.setStockType("avg_farrow_2");
                    Example<ProdProduceEntity> example6 = Example.of(delEntity6);
                    produceRepo.deleteAll(produceRepo.findAll(example6));
                    //删除平均窝产正常仔数
                    ProdProduceEntity delEntity7 = new ProdProduceEntity();
                    delEntity7.setYear(Integer.parseInt(year));
                    delEntity7.setMonth(Integer.parseInt(month));
                    delEntity7.setStockType("avg_farrow_3");
                    Example<ProdProduceEntity> example7 = Example.of(delEntity7);
                    produceRepo.deleteAll(produceRepo.findAll(example7));
                    //删除窝断奶仔猪数
                    ProdProduceEntity delEntity8 = new ProdProduceEntity();
                    delEntity8.setYear(Integer.parseInt(year));
                    delEntity8.setMonth(Integer.parseInt(month));
                    delEntity8.setStockType("break_grice");
                    Example<ProdProduceEntity> example8 = Example.of(delEntity8);
                    produceRepo.deleteAll(produceRepo.findAll(example8));
                    //删除平均窝断奶重
                    ProdProduceEntity delEntity9 = new ProdProduceEntity();
                    delEntity9.setYear(Integer.parseInt(year));
                    delEntity9.setMonth(Integer.parseInt(month));
                    delEntity9.setStockType("avg_weight");
                    Example<ProdProduceEntity> example9 = Example.of(delEntity9);
                    produceRepo.deleteAll(produceRepo.findAll(example9));
                    //删除产房成活率
                    ProdProduceEntity delEntity10 = new ProdProduceEntity();
                    delEntity10.setYear(Integer.parseInt(year));
                    delEntity10.setMonth(Integer.parseInt(month));
                    delEntity10.setStockType("nest_times");
                    Example<ProdProduceEntity> example10 = Example.of(delEntity10);
                    produceRepo.deleteAll(produceRepo.findAll(example10));
                    // 添加入库
                    for (int a = 0; a < dataJa.size(); a++) {
                        JSONObject dataJo = dataJa.getJSONObject(a);
//                        System.out.println((a + 1) + " " + dataJo);
                        String fullName = dataJo.getString("mcmc");
                        //
                        int farmId = _getFarmIdByFullName(fullName, farmNameEntityList);
                        //产房成活率
                        String cfchl = dataJo.getString("cfchl");
                        if (cfchl == null || cfchl.trim().length() == 0) {
                            cfchl = "0";
                        }
                        ProdProduceEntity addEntity1 = new ProdProduceEntity();
                        addEntity1.setFarmId(farmId);
                        addEntity1.setStockType("grice_rate");
                        addEntity1.setStockName("产房成活率");
                        addEntity1.setStockQuantity(mathUtil.formatBit(Float.parseFloat(cfchl)));
                        addEntity1.setMonth(Integer.valueOf(month));
                        addEntity1.setYear(Integer.parseInt(year));
                        produceRepo.saveAndFlush(addEntity1);

                        //保育成活率
                        String bychl = dataJo.getString("bychl");
                        if (bychl == null || bychl.trim().length() == 0) {
                            bychl = "0";
                        }
                        ProdProduceEntity addEntity2 = new ProdProduceEntity();
                        addEntity2.setFarmId(farmId);
                        addEntity2.setStockType("piglet_rate");
                        addEntity2.setStockName("保育成活率");
                        addEntity2.setStockQuantity(mathUtil.formatBit(Float.parseFloat(bychl)));
//                    stockEntity2.setRate();
                        addEntity2.setMonth(Integer.valueOf(month));
                        addEntity2.setYear(Integer.parseInt(year));
                        produceRepo.saveAndFlush(addEntity2);
                        //肥猪成活率
                        String fzchl = dataJo.getString("fzchl");
                        if (fzchl == null || fzchl.trim().length() == 0) {
                            fzchl = "0";
                        }
                        ProdProduceEntity addEntity3 = new ProdProduceEntity();
                        addEntity3.setFarmId(farmId);
                        addEntity3.setStockType("fatpig_rate");
                        addEntity3.setStockName("肥猪成活率");
                        addEntity3.setStockQuantity(mathUtil.formatBit(Float.parseFloat(fzchl)));
//                    addEntity3.setRate();
                        addEntity3.setMonth(Integer.valueOf(month));
                        addEntity3.setYear(Integer.parseInt(year));
                        produceRepo.saveAndFlush(addEntity3);

                        //平均窝产仔猪
                        String pjwczz = dataJo.getString("pjwczz");
                        if (pjwczz == null || pjwczz.trim().length() == 0) {
                            pjwczz = "0";
                        }
                        ProdProduceEntity addEntity4 = new ProdProduceEntity();
                        addEntity4.setFarmId(farmId);
                        addEntity4.setStockType("avg_farrow_1");
                        addEntity4.setStockName("平均窝产仔猪");
//                        addEntity4.setStockQuantity(mathUtil.formatBit(Float.parseFloat(pjwczz)));
                        addEntity4.setStockQuantity(df.format(Float.parseFloat(pjwczz)));
//                    addEntity4.setRate();
                        addEntity4.setMonth(Integer.valueOf(month));
                        addEntity4.setYear(Integer.parseInt(year));
                        produceRepo.saveAndFlush(addEntity4);

                        //平均窝产活仔数
                        String pjwchzs = dataJo.getString("pjwchzs");
                        if (pjwchzs == null || pjwchzs.trim().length() == 0) {
                            pjwchzs = "0";
                        }
                        ProdProduceEntity addEntity5 = new ProdProduceEntity();
                        addEntity5.setFarmId(farmId);
                        addEntity5.setStockType("avg_farrow_2");
                        addEntity5.setStockName("平均窝产活仔数");
//                        addEntity5.setStockQuantity(mathUtil.formatBit(Float.parseFloat(pjwchzs)));
                        addEntity5.setStockQuantity(df.format(Float.parseFloat(pjwchzs)));
//                    addEntity5.setRate();
                        addEntity5.setMonth(Integer.valueOf(month));
                        addEntity5.setYear(Integer.parseInt(year));
                        produceRepo.saveAndFlush(addEntity5);
                        //平均窝产正常仔数
                        String pjwczczs = dataJo.getString("pjwczczs");
                        if (pjwczczs == null || pjwczczs.trim().length() == 0) {
                            pjwczczs = "0";
                        }
                        ProdProduceEntity addEntity6 = new ProdProduceEntity();
                        addEntity6.setFarmId(farmId);
                        addEntity6.setStockType("avg_farrow_3");
                        addEntity6.setStockName("平均窝产正常仔数");
//                        addEntity6.setStockQuantity(mathUtil.formatBit(Float.parseFloat(pjwczczs)));
                        addEntity6.setStockQuantity(df.format(Float.parseFloat(pjwczczs)));
//                    addEntity6.setRate();
                        addEntity6.setMonth(Integer.valueOf(month));
                        addEntity6.setYear(Integer.parseInt(year));
                        produceRepo.saveAndFlush(addEntity6);
                        //窝断奶仔猪数
                        String wdnzzs = dataJo.getString("wdnzzs");
                        if (wdnzzs == null || wdnzzs.trim().length() == 0) {
                            wdnzzs = "0";
                        }
                        ProdProduceEntity addEntity7 = new ProdProduceEntity();
                        addEntity7.setFarmId(farmId);
                        addEntity7.setStockType("break_grice");
                        addEntity7.setStockName("窝断奶仔猪数");
//                        addEntity7.setStockQuantity(mathUtil.formatBit(Float.parseFloat(wdnzzs)));
                        addEntity7.setStockQuantity(df.format(Float.parseFloat(wdnzzs)));
//                    addEntity7.setRate();
                        addEntity7.setMonth(Integer.valueOf(month));
                        addEntity7.setYear(Integer.parseInt(year));
                        produceRepo.saveAndFlush(addEntity7);
                        //平均断奶窝重
                        String pjdnwz = dataJo.getString("pjdnwz");
                        if (pjdnwz == null || pjdnwz.trim().length() == 0) {
                            pjdnwz = "0";
                        }
                        ProdProduceEntity addEntity8 = new ProdProduceEntity();
                        addEntity8.setFarmId(farmId);
                        addEntity8.setStockType("avg_weight");
                        addEntity8.setStockName("平均断奶窝重");
//                        addEntity8.setStockQuantity(mathUtil.formatBit(Float.parseFloat(pjdnwz)));
                        addEntity8.setStockQuantity(df.format(Float.parseFloat(pjdnwz)));
//                    addEntity8.setRate();
                        addEntity8.setMonth(Integer.valueOf(month));
                        addEntity8.setYear(Integer.parseInt(year));
                        produceRepo.saveAndFlush(addEntity8);
                        //7日断配率
                        String dpl7r = dataJo.getString("7rdpl");
                        if (dpl7r == null || dpl7r.trim().length() == 0) {
                            dpl7r = "0";
                        }
                        ProdProduceEntity addEntity9 = new ProdProduceEntity();
                        addEntity9.setFarmId(farmId);
                        addEntity9.setStockType("break_rate");
                        addEntity9.setStockName("7日断配率");
                        addEntity9.setStockQuantity(mathUtil.formatBit(Float.parseFloat(dpl7r)));
//                    addEntity9.setRate();
                        addEntity9.setMonth(Integer.valueOf(month));
                        addEntity9.setYear(Integer.parseInt(year));
                        produceRepo.saveAndFlush(addEntity9);
                        //年产窝数
                        String ncws = dataJo.getString("ncws");
                        if (ncws == null || ncws.length() == 0) {
                            ncws = "0";
                        }
                        ProdProduceEntity addEntity10 = new ProdProduceEntity();
                        addEntity10.setFarmId(farmId);
                        addEntity10.setStockType("nest_times");
                        addEntity10.setStockName("年产窝数");
//                        addEntity10.setStockQuantity(mathUtil.formatBit(Float.parseFloat(ncws)));
                        addEntity10.setStockQuantity(df.format(Float.parseFloat(ncws)));
//                    addEntity10.setRate();
                        addEntity10.setMonth(Integer.valueOf(month));
                        addEntity10.setYear(Integer.parseInt(year));
                        produceRepo.saveAndFlush(addEntity10);

                        //////////////////////////////////////////////////////////////////////
                        //重要指标试点
                        //平均窝产仔数 avg_farrow_1
//                        saveImportIndicator(farmId, year, month, df.format(Float.parseFloat(pjwczz)),"avg_farrow_1","平均窝产仔猪");
                        saveImportIndicator(farmId, year, month, pjwczz, "avg_farrow_1", "平均窝产仔猪");

                        //产房成活率 grice_rate
//                        saveImportIndicator(farmId, year, month, mathUtil.formatBit(Float.parseFloat(cfchl)),"grice_rate","产房成活率");
                        saveImportIndicator(farmId, year, month, cfchl, "grice_rate", "产房成活率");

                        //保育成活率 piglet_rate
//                        saveImportIndicator(farmId, year, month, mathUtil.formatBit(Float.parseFloat(bychl)),"piglet_rate","保育成活率");
                        saveImportIndicator(farmId, year, month, bychl, "piglet_rate", "保育成活率");

                        //Step2:更新动态统计表
                        updateDynamicCount(farmId, year, month);
                    }
                }
            } else {
                System.out.println("取数失败");
            }
        } else {
            System.out.println("取数失败");
        }
    }

    //保存平均窝产仔数 avg_farrow_1、产房成活率 grice_rate、保育成活率 piglet_rate
    private void saveImportIndicator(Integer farmId, String year, String month, String inQuantity, String type, String title) {
        DecimalFormat df = new DecimalFormat("0.00");
        System.out.println("//////////////////////////////////////////////////////////////////////////////////");
        System.out.println("inQuantity>>" + inQuantity);
        //计算前一个月（年、月）
        Map beforeMonthMap = dateUtil.getBeforeMonth();

        //计算涨跌
        JSONObject riseFallJo = new JSONObject();
        if (type.trim().equalsIgnoreCase("avg_farrow_1")) {
            riseFallJo = getBeforeLastMonth(farmId, beforeMonthMap, type, df.format(Float.parseFloat(inQuantity)));
//            riseFallJo = getBeforeLastMonth(farmId, beforeMonthMap, type, inQuantity);
        }else{
//            riseFallJo = getBeforeLastMonth2(farmId, beforeMonthMap, type, mathUtil.formatBit(Float.parseFloat(inQuantity),3));
            riseFallJo = getBeforeLastMonth2(farmId, beforeMonthMap, type, inQuantity);
        }
        System.out.println("## riseFallJo>>" + riseFallJo);

        //Step1:保存到重要指标
        //删除旧数据
        ProdImportantIndicatorEntity delEntity5 = new ProdImportantIndicatorEntity();
        delEntity5.setYear(Integer.parseInt(year));
        delEntity5.setMonth(Integer.parseInt(month));
        delEntity5.setFarmId(farmId);
        delEntity5.setStockType(type);
        Example<ProdImportantIndicatorEntity> example5 = Example.of(delEntity5);
        prodImportantIndicatorRepo.deleteAll(prodImportantIndicatorRepo.findAll(example5));
        //添加新数据
        ProdImportantIndicatorEntity addEntity4 = new ProdImportantIndicatorEntity();
        addEntity4.setFarmId(farmId);
        addEntity4.setStockType(type);
        addEntity4.setStockName(title);
        if (type.trim().equalsIgnoreCase("avg_farrow_1")) {
            addEntity4.setStockQuantity(df.format(Float.parseFloat(inQuantity)));
        } else {
            addEntity4.setStockQuantity(mathUtil.countRate(Float.parseFloat(inQuantity),1)+"%");
        }
        addEntity4.setMonth(Integer.valueOf(month));
        addEntity4.setYear(Integer.parseInt(year));
        //涨跌
        addEntity4.setRiseFall(riseFallJo.getInteger("rise_fall"));
        //幅度
        addEntity4.setRange1(riseFallJo.getString("range"));
        System.out.println("addEntity4>>" + addEntity4);
        prodImportantIndicatorRepo.saveAndFlush(addEntity4);
    }

    //更新当前月统计指标
    private void updateDynamicCount(Integer farmId, String year, String month) {
        //查找前一个月的数据
        ProdImportantIndicatorEntity findImportantEntity = new ProdImportantIndicatorEntity();
        findImportantEntity.setYear(Integer.parseInt(year));
        findImportantEntity.setMonth(Integer.parseInt(month));
        findImportantEntity.setFarmId(farmId);
        Example<ProdImportantIndicatorEntity> beforeExample = Example.of(findImportantEntity);
        List<ProdImportantIndicatorEntity> beforeImportantEntityList = prodImportantIndicatorRepo.findAll(beforeExample);
        int up = 0;
        int down = 0;
        int flat = 0;
        for (ProdImportantIndicatorEntity importantEntity : beforeImportantEntityList) {
            if (importantEntity.getRange1().trim().equalsIgnoreCase("0")) {
                flat++;
            } else {
                if (importantEntity.getRiseFall() == 1) {
                    up++;
                } else {
                    down++;
                }
            }
        }
        int total = up + down + flat;
        ProdIndicatorDynamicEntity delDynamicEntity = new ProdIndicatorDynamicEntity();
        delDynamicEntity.setYear(Integer.parseInt(year));
        delDynamicEntity.setMonth(Integer.parseInt(month));
        delDynamicEntity.setFarmId(farmId);
        Example<ProdIndicatorDynamicEntity> delExample3 = Example.of(delDynamicEntity);
        Optional<ProdIndicatorDynamicEntity> dynamicOptional = prodIndicatorDynamicRepo.findOne(delExample3);
        if (dynamicOptional.isPresent()) {
            ProdIndicatorDynamicEntity existDynamicEntity = dynamicOptional.get();
            existDynamicEntity.setTotal(total);
            existDynamicEntity.setUp(up);
            existDynamicEntity.setDown(down);
            existDynamicEntity.setFlat(flat);
            prodIndicatorDynamicRepo.saveAndFlush(existDynamicEntity);
        } else {
            ProdIndicatorDynamicEntity addDynamicEntity = new ProdIndicatorDynamicEntity();
            addDynamicEntity.setFarmId(farmId);
            addDynamicEntity.setYear(Integer.parseInt(year));
            addDynamicEntity.setMonth(Integer.parseInt(month));
            addDynamicEntity.setTotal(total);
            addDynamicEntity.setUp(up);
            addDynamicEntity.setDown(down);
            addDynamicEntity.setFlat(flat);
            prodIndicatorDynamicRepo.saveAndFlush(addDynamicEntity);
        }
    }

    //
    private JSONObject getBeforeLastMonth(Integer farmId, Map beforeMonthMap, String type, String newValue) {
        System.out.println("##22 newValue>>" + newValue);
//        df.format(Float.parseFloat(inQuantity))
        String beforeMonth = beforeMonthMap.get("month").toString();
        String beforeYear = beforeMonthMap.get("year").toString();
        //查找前一个月的数据
        ProdImportantIndicatorEntity findImportantEntity = new ProdImportantIndicatorEntity();
        findImportantEntity.setYear(Integer.parseInt(beforeYear));
        findImportantEntity.setMonth(Integer.parseInt(beforeMonth));
        findImportantEntity.setStockType(type);
        findImportantEntity.setFarmId(farmId);
        Example<ProdImportantIndicatorEntity> beforeExample = Example.of(findImportantEntity);
//        List<ProdImportantIndicatorEntity> beforeImportantEntityList = prodImportantIndicatorRepo.findAll(beforeExample);
        Optional<ProdImportantIndicatorEntity> optional = prodImportantIndicatorRepo.findOne(beforeExample);
        JSONObject outJo = new JSONObject();
        System.out.println("optional.isPresent()>>" + optional.isPresent());
        if (optional.isPresent()) {
            System.out.println("true");
            ProdImportantIndicatorEntity importantEntity = optional.get();
            System.out.println(">>importantEntity.getStockQuantity()>>" + importantEntity.getStockQuantity());
            BigDecimal beforeQuantityBd = new BigDecimal(importantEntity.getStockQuantity());
            BigDecimal quantityBd = new BigDecimal(newValue);
            if (quantityBd.compareTo(beforeQuantityBd) == 0) {
                outJo.put("rise_fall", 1);
                outJo.put("range", "0");
                System.out.println("1");
            } else if (quantityBd.compareTo(beforeQuantityBd) == 1) {
                outJo.put("rise_fall", 1);
                outJo.put("range", quantityBd.subtract(beforeQuantityBd));
                System.out.println("2");
            } else {
                outJo.put("rise_fall", 0);
                outJo.put("range", beforeQuantityBd.subtract(quantityBd));
                System.out.println("3");
            }
        } else {
            System.out.println("false");
            outJo.put("rise_fall", 1);
            outJo.put("range", newValue);
        }
        return outJo;
    }

    //
    private JSONObject getBeforeLastMonth2(Integer farmId, Map beforeMonthMap, String type, String newValue) {
        System.out.println("##22 newValue>>" + newValue);
        newValue = mathUtil.countRate(Float.parseFloat(newValue),1);
//        mathUtil.formatBit(Float.parseFloat(inQuantity),3)
        String beforeMonth = beforeMonthMap.get("month").toString();
        String beforeYear = beforeMonthMap.get("year").toString();
        //查找前一个月的数据
        ProdImportantIndicatorEntity findImportantEntity = new ProdImportantIndicatorEntity();
        findImportantEntity.setYear(Integer.parseInt(beforeYear));
        findImportantEntity.setMonth(Integer.parseInt(beforeMonth));
        findImportantEntity.setStockType(type);
        findImportantEntity.setFarmId(farmId);
        Example<ProdImportantIndicatorEntity> beforeExample = Example.of(findImportantEntity);
//        List<ProdImportantIndicatorEntity> beforeImportantEntityList = prodImportantIndicatorRepo.findAll(beforeExample);
        Optional<ProdImportantIndicatorEntity> optional = prodImportantIndicatorRepo.findOne(beforeExample);
        JSONObject outJo = new JSONObject();
        System.out.println("optional.isPresent()>>" + optional.isPresent());
        if (optional.isPresent()) {
            System.out.println("true");
            ProdImportantIndicatorEntity importantEntity = optional.get();
            System.out.println(">>importantEntity.getStockQuantity()>>" + importantEntity.getStockQuantity());
            System.out.println(">>newValue>>"+newValue);
            BigDecimal beforeQuantityBd = new BigDecimal(importantEntity.getStockQuantity().replace("%",""));
            BigDecimal quantityBd = new BigDecimal(newValue);
            if (quantityBd.compareTo(beforeQuantityBd) == 0) {
                outJo.put("rise_fall", 1);
                outJo.put("range", "0");
                System.out.println("1");
            } else if (quantityBd.compareTo(beforeQuantityBd) == 1) {
                outJo.put("rise_fall", 1);
                outJo.put("range", mathUtil.countRate(Float.parseFloat(quantityBd.subtract(beforeQuantityBd).toString()),1)+"%");
                System.out.println("2");
            } else {
                outJo.put("rise_fall", 0);
                outJo.put("range", mathUtil.countRate(Float.parseFloat(beforeQuantityBd.subtract(quantityBd).toString()),1) +"%");
                System.out.println("3");
            }
        } else {
            System.out.println("false");
            outJo.put("rise_fall", 1);
            outJo.put("range", mathUtil.countRate(Float.parseFloat(newValue),1) +"%");
        }
        return outJo;
    }

    //读取ERP数据中对应的名称
    private int _getFarmIdByFullName(String pigfarm, List<ProdFarmNameEntity> farmNameEntityList) {
        //
        int farmId = 0;
        boolean isExist = false;
        for (ProdFarmNameEntity prodFarmNameEntity : farmNameEntityList) {
            if (prodFarmNameEntity.getErpShortName() != null && prodFarmNameEntity.getErpFarmName().equalsIgnoreCase(pigfarm)) {
                farmId = prodFarmNameEntity.getFarmId();
                isExist = true;
                break;
            }
        }
        if (!isExist) {
            log.info("牧场全称‘" + pigfarm + "’在prod_farm_name表中不存在对应的数据.");
        }
        return farmId;
    }

    private String getToken() {
        JSONObject token = template.getForObject("http://127.0.0.1:9100/token/getToken?userId=20210501&timestamp=45546546454&random=1156&sign=7fa431325504e01e9fa87ed0e274c40c",
                JSONObject.class);
        return token.getString("accessToken");

    }

    @Override
    public String getRemoteToken() throws IOException {
//        JSONObject token = template.getForObject(apiIp + apiPort +"/token/getToken?userId=20210501&timestamp=45546546454&random=1156&sign=7fa431325504e01e9fa87ed0e274c40c",
//                JSONObject.class);
        Map<String, String> paramsMap = new HashMap<String, String>();
        paramsMap.put("userId", "20210501");
        paramsMap.put("timestamp", "45546546454");
        paramsMap.put("random", "1156");
        paramsMap.put("sign", "7fa431325504e01e9fa87ed0e274c40c");

        Map<String, Integer> timeoutMap = new HashMap<String, Integer>();
        timeoutMap.put("connectTimeout", Integer.parseInt(connectTimeout));
        timeoutMap.put("requestTimeout", Integer.parseInt(requestTimeout));
        timeoutMap.put("socketTimeout", Integer.parseInt(socketTimeout));
        String url = apiIp + apiPort + "/token/getToken";
        //
        JSONObject outJo = httpClientUtil.doGet(url, paramsMap, timeoutMap);
        if (outJo.getBoolean("status")) {
            return outJo.getJSONObject("content").getString("accessToken");
        } else {
            return outJo.getString("content");
        }
    }

    @Override
    public void getManyFarmStock() throws IOException {
        String year = dateUtil.getThisYear();
        String month = dateUtil.getThisMonth();
        //
        String token = getRemoteToken();
        Map<String, String> paramsMap = new HashMap<String, String>();
        paramsMap.put("accessToken", token);
        Map<String, Integer> timeoutMap = new HashMap<String, Integer>();
        timeoutMap.put("connectTimeout", Integer.parseInt(connectTimeout));
        timeoutMap.put("requestTimeout", Integer.parseInt(connectTimeout));
        timeoutMap.put("socketTimeout", Integer.parseInt(connectTimeout));
        String url = apiIp + apiPort + serviceName + "/getManyFarmStock";
        log.info("获取多个牧场的存栏数据请求地址=" + url);
        log.info("业务请求参数=" + paramsMap.toString());
        log.info("超时参数=" + timeoutMap.toString());
        log.info("开始取数＝" + new Date(System.currentTimeMillis()));
        //
        JSONObject outJo = httpClientUtil.doGet(url, paramsMap, timeoutMap);
        log.info("返回结果=" + outJo);
        log.info("结束取数=" + new Date(System.currentTimeMillis()));
        if (outJo.getBoolean("status")) {
            JSONObject contentJo = outJo.getJSONObject("content");
            if (contentJo.getBoolean("success")) {
                JSONArray dataJa = contentJo.getJSONArray("data");
                if (dataJa.size() > 0) {
                    //获取牧场所有名称数据
                    List<ProdFarmNameEntity> farmNameEntityList = prodFarmNameRepo.findAll();
                    //删除旧数据
                    //母猪存栏
                    ProdStockEntity delStockEntity1 = new ProdStockEntity();
                    delStockEntity1.setYear(Integer.parseInt(year));
                    delStockEntity1.setMonth(Integer.parseInt(month));
                    delStockEntity1.setStockType("sow_stock");
                    Example<ProdStockEntity> example = Example.of(delStockEntity1);
//                    prodStockRepo.delete(prodStockRepo.findOne(example).get());
                    prodStockRepo.deleteAll(prodStockRepo.findAll(example));
                    //公猪存栏
                    ProdStockEntity delStockEntity2 = new ProdStockEntity();
                    delStockEntity2.setYear(Integer.parseInt(year));
                    delStockEntity2.setMonth(Integer.parseInt(month));
                    delStockEntity2.setStockType("boar_stock");
                    Example<ProdStockEntity> example2 = Example.of(delStockEntity2);
//                    prodStockRepo.delete(prodStockRepo.findOne(example2).get());
                    prodStockRepo.deleteAll(prodStockRepo.findAll(example2));
                    //哺乳猪存栏/仔猪存栏
                    ProdStockEntity delStockEntity3 = new ProdStockEntity();
                    delStockEntity3.setYear(Integer.parseInt(year));
                    delStockEntity3.setMonth(Integer.parseInt(month));
                    delStockEntity3.setStockType("grice_stock");
                    Example<ProdStockEntity> example3 = Example.of(delStockEntity3);
//                    prodStockRepo.delete(prodStockRepo.findOne(example3).get());
                    prodStockRepo.deleteAll(prodStockRepo.findAll(example3));
                    //保育猪存栏
                    ProdStockEntity delStockEntity4 = new ProdStockEntity();
                    delStockEntity4.setYear(Integer.parseInt(year));
                    delStockEntity4.setMonth(Integer.parseInt(month));
                    delStockEntity4.setStockType("piglet_stock");
                    Example<ProdStockEntity> example4 = Example.of(delStockEntity4);
//                    prodStockRepo.delete(prodStockRepo.findOne(example4).get());
                    prodStockRepo.deleteAll(prodStockRepo.findAll(example4));
                    //育肥猪存栏
                    ProdStockEntity delStockEntity5 = new ProdStockEntity();
                    delStockEntity5.setYear(Integer.parseInt(year));
                    delStockEntity5.setMonth(Integer.parseInt(month));
                    delStockEntity5.setStockType("fatpig_stock");
                    Example<ProdStockEntity> example5 = Example.of(delStockEntity5);
//                    prodStockRepo.delete(prodStockRepo.findOne(example5).get());
                    prodStockRepo.deleteAll(prodStockRepo.findAll(example5));
                    //总存栏
                    ProdStockEntity delStockEntity6 = new ProdStockEntity();
                    delStockEntity6.setYear(Integer.parseInt(year));
                    delStockEntity6.setMonth(Integer.parseInt(month));
                    delStockEntity6.setStockType("total_stock");
                    Example<ProdStockEntity> example6 = Example.of(delStockEntity6);
//                    prodStockRepo.delete(prodStockRepo.findOne(example6).get());
                    prodStockRepo.deleteAll(prodStockRepo.findAll(example6));
                    //妊娠
                    ProdStockEntity delStockEntity7 = new ProdStockEntity();
                    delStockEntity7.setYear(Integer.parseInt(year));
                    delStockEntity7.setMonth(Integer.parseInt(month));
                    delStockEntity7.setStockType("sow_stock_1");
                    Example<ProdStockEntity> example7 = Example.of(delStockEntity7);
//                    prodStockRepo.delete(prodStockRepo.findOne(example7).get());
                    prodStockRepo.deleteAll(prodStockRepo.findAll(example7));
                    //哺乳
                    ProdStockEntity delStockEntity8 = new ProdStockEntity();
                    delStockEntity8.setYear(Integer.parseInt(year));
                    delStockEntity8.setMonth(Integer.parseInt(month));
                    delStockEntity8.setStockType("sow_stock_2");
                    Example<ProdStockEntity> example8 = Example.of(delStockEntity8);
//                    prodStockRepo.delete(prodStockRepo.findOne(example8).get());
                    prodStockRepo.deleteAll(prodStockRepo.findAll(example8));
                    //空怀(空怀包含返情)
                    ProdStockEntity delStockEntity9 = new ProdStockEntity();
                    delStockEntity9.setYear(Integer.parseInt(year));
                    delStockEntity9.setMonth(Integer.parseInt(month));
                    delStockEntity9.setStockType("sow_stock_3");
                    prodStockRepo.delete(delStockEntity9);
                    Example<ProdStockEntity> example9 = Example.of(delStockEntity9);
//                    prodStockRepo.delete(prodStockRepo.findOne(example9).get());
                    prodStockRepo.deleteAll(prodStockRepo.findAll(example9));
                    //后备
                    ProdStockEntity delStockEntity10 = new ProdStockEntity();
                    delStockEntity10.setYear(Integer.parseInt(year));
                    delStockEntity10.setMonth(Integer.parseInt(month));
                    delStockEntity10.setStockType("sow_stock_5");
                    Example<ProdStockEntity> example10 = Example.of(delStockEntity10);
//                    prodStockRepo.delete(prodStockRepo.findOne(example10).get());
                    prodStockRepo.deleteAll(prodStockRepo.findAll(example10));
//                    prodStockRepo.deleteByYearAndMonth(Integer.parseInt(year),Integer.parseInt(month));
                    //商品猪
                    ProdStockEntity delStockEntity11 = new ProdStockEntity();
                    delStockEntity11.setYear(Integer.parseInt(year));
                    delStockEntity11.setMonth(Integer.parseInt(month));
                    delStockEntity11.setStockType("business_stock");
                    Example<ProdStockEntity> example11 = Example.of(delStockEntity11);
                    prodStockRepo.deleteAll(prodStockRepo.findAll(example11));

                    // 添加入库
                    for (int a = 0; a < dataJa.size(); a++) {
                        JSONObject dataJo = dataJa.getJSONObject(a);
                        //
                        int farmId = _getFarmIdByShortName(dataJo.getString("mcmc"), farmNameEntityList);
                        int mz = dataJo.getInteger("mz");
                        int gz = dataJo.getInteger("gz");
                        int zz = dataJo.getInteger("zz");
                        int by = dataJo.getInteger("by");
                        int yf = dataJo.getInteger("yf");
                        int total = mz + gz + zz + by + yf;
                        System.out.println("mz=" + mz);
                        System.out.println("gz=" + gz);
                        System.out.println("zz=" + zz);
                        System.out.println("by=" + by);
                        System.out.println("yf=" + yf);
                        System.out.println("total=" + total);
                        //母猪存栏
                        ProdStockEntity stockEntity1 = new ProdStockEntity();
                        stockEntity1.setFarmId(farmId);
                        stockEntity1.setStockType("sow_stock");
                        stockEntity1.setStockName("母猪存栏");
                        stockEntity1.setStockQuantity(dataJo.getString("mz"));
                        if (total == 0) {
                            stockEntity1.setRate(Float.parseFloat("0"));
                        } else {
                            stockEntity1.setRate(Float.parseFloat(mathUtil.countRate(mz, total, 1)));
                        }
                        stockEntity1.setMonth(Integer.valueOf(month));
                        stockEntity1.setYear(Integer.parseInt(year));
                        prodStockRepo.saveAndFlush(stockEntity1);
                        //公猪存栏
                        ProdStockEntity stockEntity2 = new ProdStockEntity();
                        stockEntity2.setFarmId(farmId);
                        stockEntity2.setStockType("boar_stock");
                        stockEntity2.setStockName("公猪存栏");
                        stockEntity2.setStockQuantity(dataJo.getString("gz"));
                        if (total == 0) {
                            stockEntity2.setRate(Float.parseFloat("0"));
                        } else {
                            stockEntity2.setRate(Float.parseFloat(mathUtil.countRate(gz, total, 1)));
                        }
                        stockEntity2.setMonth(Integer.valueOf(month));
                        stockEntity2.setYear(Integer.parseInt(year));
                        prodStockRepo.saveAndFlush(stockEntity2);
                        //哺乳猪存栏/仔猪存栏
                        ProdStockEntity stockEntity3 = new ProdStockEntity();
                        stockEntity3.setFarmId(farmId);
                        stockEntity3.setStockType("grice_stock");
                        stockEntity3.setStockName("哺乳猪存栏");
                        stockEntity3.setStockQuantity(dataJo.getString("zz"));
                        if (total == 0) {
                            stockEntity3.setRate(Float.parseFloat("0"));
                        } else {
                            stockEntity3.setRate(Float.parseFloat(mathUtil.countRate(zz, total, 1)));
                        }
                        stockEntity3.setMonth(Integer.valueOf(month));
                        stockEntity3.setYear(Integer.parseInt(year));
                        prodStockRepo.saveAndFlush(stockEntity3);
                        //保育猪存栏
                        ProdStockEntity stockEntity4 = new ProdStockEntity();
                        stockEntity4.setFarmId(farmId);
                        stockEntity4.setStockType("piglet_stock");
                        stockEntity4.setStockName("保育猪存栏");
                        stockEntity4.setStockQuantity(dataJo.getString("by"));
                        if (total == 0) {
                            stockEntity4.setRate(Float.parseFloat("0"));
                        } else {
                            stockEntity4.setRate(Float.parseFloat(mathUtil.countRate(by, total, 1)));
                        }
                        stockEntity4.setMonth(Integer.valueOf(month));
                        stockEntity4.setYear(Integer.parseInt(year));
                        prodStockRepo.saveAndFlush(stockEntity4);
                        //育肥猪存栏
                        ProdStockEntity stockEntity5 = new ProdStockEntity();
                        stockEntity5.setFarmId(farmId);
                        stockEntity5.setStockType("fatpig_stock");
                        stockEntity5.setStockName("育肥猪存栏");
                        stockEntity5.setStockQuantity(dataJo.getString("yf"));
                        if (total == 0) {
                            stockEntity5.setRate(Float.parseFloat("0"));
                        } else {
                            stockEntity5.setRate(Float.parseFloat(mathUtil.countRate(yf, total, 1)));
                        }
                        stockEntity5.setMonth(Integer.valueOf(month));
                        stockEntity5.setYear(Integer.parseInt(year));
                        prodStockRepo.saveAndFlush(stockEntity5);
                        //总存栏
                        ProdStockEntity stockEntity6 = new ProdStockEntity();
                        stockEntity6.setFarmId(farmId);
                        stockEntity6.setStockType("total_stock");
                        stockEntity6.setStockName("总存栏");
                        stockEntity6.setStockQuantity(String.valueOf(total));
                        stockEntity6.setMonth(Integer.valueOf(month));
                        stockEntity6.setYear(Integer.parseInt(year));
                        prodStockRepo.saveAndFlush(stockEntity6);

                        //妊娠
                        ProdStockEntity stockEntity7 = new ProdStockEntity();
                        stockEntity7.setFarmId(farmId);
                        stockEntity7.setStockType("sow_stock_1");
                        stockEntity7.setStockName("妊娠");
                        stockEntity7.setStockQuantity(String.valueOf(dataJo.getInteger("rs")));
                        stockEntity7.setMonth(Integer.valueOf(month));
                        stockEntity7.setYear(Integer.parseInt(year));
                        prodStockRepo.saveAndFlush(stockEntity7);
                        //哺乳
                        ProdStockEntity stockEntity8 = new ProdStockEntity();
                        stockEntity8.setFarmId(farmId);
                        stockEntity8.setStockType("sow_stock_2");
                        stockEntity8.setStockName("哺乳");
                        stockEntity8.setStockQuantity(String.valueOf(dataJo.getInteger("br")));
                        stockEntity8.setMonth(Integer.valueOf(month));
                        stockEntity8.setYear(Integer.parseInt(year));
                        prodStockRepo.saveAndFlush(stockEntity8);
                        //空怀(包含返情)
                        ProdStockEntity stockEntity9 = new ProdStockEntity();
                        stockEntity9.setFarmId(farmId);
                        stockEntity9.setStockType("sow_stock_3");
                        stockEntity9.setStockName("空怀");
                        stockEntity9.setStockQuantity(String.valueOf(dataJo.getInteger("kh")));
                        stockEntity9.setMonth(Integer.valueOf(month));
                        stockEntity9.setYear(Integer.parseInt(year));
                        prodStockRepo.saveAndFlush(stockEntity9);
                        //后备
                        ProdStockEntity stockEntity10 = new ProdStockEntity();
                        stockEntity10.setFarmId(farmId);
                        stockEntity10.setStockType("sow_stock_5");
                        stockEntity10.setStockName("后备");
                        stockEntity10.setStockQuantity(String.valueOf(dataJo.getInteger("hb")));
                        stockEntity10.setMonth(Integer.valueOf(month));
                        stockEntity10.setYear(Integer.parseInt(year));
                        prodStockRepo.saveAndFlush(stockEntity10);
                        //商品猪=仔猪+保育+育肥+后备
                        ProdStockEntity stockEntity11 = new ProdStockEntity();
                        stockEntity11.setFarmId(farmId);
                        stockEntity11.setStockType("business_stock");
                        stockEntity11.setStockName("商品猪");
                        stockEntity11.setStockQuantity(String.valueOf(dataJo.getInteger("zz") + dataJo.getInteger("by") + dataJo.getInteger("yf") + dataJo.getInteger("hb")));
                        stockEntity11.setMonth(Integer.valueOf(month));
                        stockEntity11.setYear(Integer.parseInt(year));
                        prodStockRepo.saveAndFlush(stockEntity11);
                    }

                }
            } else {
                log.info("取数失败");
            }
        } else {
            log.info("取数失败");
        }
    }

    //读取ERP数据中对应的名称
    private int _getFarmIdByShortName(String pigfarm, List<ProdFarmNameEntity> farmNameEntityList) {
        //
        int farmId = 0;
        boolean isExist = false;
        for (ProdFarmNameEntity prodFarmNameEntity : farmNameEntityList) {
            if (prodFarmNameEntity.getErpShortName() != null && prodFarmNameEntity.getErpShortName().equalsIgnoreCase(pigfarm)) {
                farmId = prodFarmNameEntity.getFarmId();
                isExist = true;
                break;
            }
        }
        if (!isExist) {
            log.info("牧场简称‘" + pigfarm + "’在prod_farm_name表中不存在对应的数据.");
        }
        return farmId;
    }

    @Autowired
    private ProdCostStatisticsRepo costStatisticsRepo;

    @Override
    public void getCostWithManyFarm() throws IOException, ParseException {

        //
        String token = getRemoteToken();
        //
        Map<String, String> paramsMap = new HashMap<String, String>();
        paramsMap.put("accessToken", token);
//        paramsMap.put("year", dateUtil.getThisYear());
//        paramsMap.put("month", dateUtil.getThisMonth());
        // test data
        paramsMap.put("year", "2021");
        paramsMap.put("month", "8");
        //
        Map<String, Integer> timeoutMap = new HashMap<String, Integer>();
        timeoutMap.put("connectTimeout", Integer.parseInt(connectTimeout));
        timeoutMap.put("requestTimeout", Integer.parseInt(requestTimeout));
        timeoutMap.put("socketTimeout", Integer.parseInt(socketTimeout));
        String url = apiIp + apiPort + serviceName + "/getCostWithManyFarm";
        log.info("获取多个牧场的成本数据访问地址=" + url);
        log.info("业务请求参数=" + paramsMap.toString());
        log.info("超时参数=" + timeoutMap.toString());
        log.info("开始取数=" + new Date(System.currentTimeMillis()));
        //
        JSONObject outJo = httpClientUtil.doGet(url, paramsMap, timeoutMap);
        log.info("返回结果=" + outJo);
        log.info("结束取数=" + new Date(System.currentTimeMillis()));
        if (outJo.getBoolean("status")) {
            JSONObject contentJo = outJo.getJSONObject("content");
            if (contentJo.getBoolean("success")) {
                JSONArray dataJa = contentJo.getJSONArray("data");
                if (dataJa.size() == 0) {
                    log.info("未取到数据 。");
                } else {
                    //删除当天旧数据
                    ProdCostStatisticsEntity delCostStatisticsEntity = new ProdCostStatisticsEntity();
                    delCostStatisticsEntity.setAddDate(dateUtil.getTodayDate());
                    Example<ProdCostStatisticsEntity> example = Example.of(delCostStatisticsEntity);
                    costStatisticsRepo.deleteAll(costStatisticsRepo.findAll(example));

                    //获取牧场所有名称数据
                    List<ProdFarmNameEntity> farmNameEntityList = prodFarmNameRepo.findAll();
                    // 添加入库
                    for (int a = 0; a < dataJa.size(); a++) {
                        JSONObject dataJo = dataJa.getJSONObject(a);
//                        System.out.println((a + 1) + " " + dataJo);
                        ProdCostStatisticsEntity costStatisticsEntity = new ProdCostStatisticsEntity();
                        costStatisticsEntity.setFarmName(dataJo.getString("mcmc"));
                        //牧场名称
                        costStatisticsEntity.setFarmId(_getFarmIdByShortName(dataJo.getString("mcmc"), farmNameEntityList));
                        costStatisticsEntity.setBaseGroup(mathUtil.format1(dataJo.getString("jczq")));
                        costStatisticsEntity.setPigletGroup(mathUtil.format1(dataJo.getString("byzq")));
                        costStatisticsEntity.setFattenPig(mathUtil.format1(dataJo.getString("yf")));
                        costStatisticsEntity.setReplaceGilt(mathUtil.format1(dataJo.getString("hb")));
                        costStatisticsEntity.setCommonCost(mathUtil.format1(dataJo.getString("gtfy")));
                        costStatisticsEntity.setTotal(mathUtil.format1(dataJo.getString("hj")));
                        costStatisticsEntity.setProjectName(dataJo.getString("xmmc"));
                        costStatisticsEntity.setAddDate(new java.util.Date());
                        costStatisticsRepo.save(costStatisticsEntity);
                    }
                }
            } else {
                System.out.println("取数失败");
            }
        } else {
            System.out.println("取数失败");
        }
    }

    /**
     * @Method : getWarningMessage
     * @Description :
     * @Params : []
     * @Return : void
     * @Author : ZhuoNing
     * @Date : 2021/11/19
     * @Time : 15:48
     */
    @Override
    public void getWarningMessage() throws IOException, ParseException {
        //
        String token = getRemoteToken();
        //
        Map<String, String> paramsMap = new HashMap<String, String>();
        paramsMap.put("accessToken", token);
        //
        Map<String, Integer> timeoutMap = new HashMap<String, Integer>();
        timeoutMap.put("connectTimeout", Integer.parseInt(connectTimeout));
        timeoutMap.put("requestTimeout", Integer.parseInt(requestTimeout));
        timeoutMap.put("socketTimeout", Integer.parseInt(socketTimeout));
        String url = apiIp + apiPort + serviceName + "/getWarningMessage";
        log.info("获取预警数据访问地址=" + url);
        log.info("业务请求参数=" + paramsMap.toString());
        log.info("超时参数=" + timeoutMap.toString());
        log.info("开始取数=" + new Date(System.currentTimeMillis()));
        //
        JSONObject outJo = httpClientUtil.doGet(url, paramsMap, timeoutMap);
        log.info("返回结果=" + outJo);
        log.info("结束取数=" + new Date(System.currentTimeMillis()));
        if (outJo.getBoolean("status")) {
            JSONObject contentJo = outJo.getJSONObject("content");
            if (contentJo.getBoolean("success")) {
                JSONArray dataJa = contentJo.getJSONArray("data");
                if (dataJa.size() == 0) {
                    log.info("未取到数据 。");
                }
                //删除当天旧数据
                ProdWarningMsgEntity delWarningMsgEntity = new ProdWarningMsgEntity();
                delWarningMsgEntity.setAddTime(dateUtil.getTodayDate());
                Example<ProdWarningMsgEntity> example = Example.of(delWarningMsgEntity);
                warningMsgRepo.deleteAll(warningMsgRepo.findAll(example));
                //获取牧场所有名称数据
                List<ProdFarmNameEntity> farmNameEntityList = prodFarmNameRepo.findAll();
//                for (ProdFarmNameEntity farmNameEntity : farmNameEntityList) {
//                    System.out.println("" + farmNameEntity.toString());
//                }
                // 添加入库
                for (int a = 0; a < dataJa.size(); a++) {
                    JSONObject dataJo = dataJa.getJSONObject(a);
                    System.out.println((a + 1) + " " + dataJo);
                    String content = dataJo.getString("xxnr").trim();
                    String[] contentArray = content.split("-");
                    String pigfarm = "";
                    String message = "";
                    if (contentArray.length >= 2) {
                        pigfarm = contentArray[0];
                        message = content.replace(pigfarm + "-", "").trim();
                    } else {
                        pigfarm = content.substring(0, 3);
                        message = content.substring(3, content.length());
                    }
//                    System.out.println((a+1)+" "+dateUtil.formatDateTime(dataJo.getString("tsrq"))+","+pigfarm+","+message+" length="+contentArray.length);
                    ProdWarningMsgEntity newWarningMsgEntity = new ProdWarningMsgEntity();
                    newWarningMsgEntity.setTipTime(dateUtil.formatDateTime(dataJo.getString("tsrq")));
                    newWarningMsgEntity.setFarmName(pigfarm);
                    newWarningMsgEntity.setWarningContent(message);
                    //
                    newWarningMsgEntity.setFarmId(_getFarmId(pigfarm, farmNameEntityList));
                    newWarningMsgEntity.setAddTime(new Timestamp(new Date().getTime()));
                    newWarningMsgEntity.setHandleState(0);
                    ProdWarningMsgEntity outWarningMsgEntity = warningMsgRepo.saveAndFlush(newWarningMsgEntity);
                }
            } else {
                System.out.println("取数失败");
            }
        } else {
            System.out.println("取数失败");
        }
    }

    //读取ERP数据中对应的名称
    private int _getFarmId(String pigfarm, List<ProdFarmNameEntity> farmNameEntityList) {
        //
        int farmId = 0;
        boolean isExist = false;
        for (ProdFarmNameEntity prodFarmNameEntity : farmNameEntityList) {
            if (prodFarmNameEntity.getErpShortName() != null && (prodFarmNameEntity.getErpShortName().indexOf(pigfarm) != -1 || pigfarm.equalsIgnoreCase(prodFarmNameEntity.getErpWarnFarmName()))) {
                farmId = prodFarmNameEntity.getFarmId();
                isExist = true;
                break;
            }
        }
        if (!isExist) {
            log.info("牧场简称‘" + pigfarm + "’在prod_farm_name表中不存在对应的数据.");
        }
        return farmId;
    }

    @Override
    public void getWorkPlan() throws IOException, ParseException {
        //
        Map timeoutMap = httpClientUtil.setTimeout(connectTimeout, requestTimeout, socketTimeout);
        //
        String token = getRemoteToken();
        //
        Map<String, String> paramsMap = new HashMap<String, String>();
        paramsMap.put("accessToken", token);
        //未来1天日期
        String startDate = dateUtil.getFetureDate(1);
        //未来7天日期
        String endDate = dateUtil.getFetureDate(7);
        paramsMap.put("startDate", startDate);
        paramsMap.put("endDate", endDate);


        String url = apiIp + apiPort + serviceName + "/getWorkPlan";
        log.info("获取工作计划数据访问地址=" + url);
        log.info("业务请求参数=" + paramsMap.toString());
        log.info("开始取数=" + new Date(System.currentTimeMillis()));
        //
        JSONObject outJo = httpClientUtil.doGet(url, paramsMap);
        log.info("返回结果=" + outJo);
        log.info("结束取数=" + new Date(System.currentTimeMillis()));
        if (outJo.getBoolean("status")) {
            JSONObject contentJo = outJo.getJSONObject("content");
            if (contentJo.getBoolean("success")) {
                JSONArray dataJa = contentJo.getJSONArray("data");
                if (dataJa.size() == 0) {
                    log.info("未取到数据 。");
                } else {
                    //删除旧数据
                    ProdWorkPlanEntity delWorkPlanEntity = new ProdWorkPlanEntity();
                    delWorkPlanEntity.setAddTime(dateUtil.getTodayDate());
                    Example<ProdWorkPlanEntity> example = Example.of(delWorkPlanEntity);
                    workPlanRepo.deleteAll(workPlanRepo.findAll(example));
                    //获取牧场所有名称数据
                    List<ProdFarmNameEntity> farmNameEntityList = prodFarmNameRepo.findAll();
                    for (int a = 0; a < dataJa.size(); a++) {
                        JSONObject dataJo = dataJa.getJSONObject(a);
                        System.out.println((a + 1) + " " + dataJo);
                        ProdWorkPlanEntity workPlanEntity = new ProdWorkPlanEntity();
                        workPlanEntity.setFarmId(_getFarmIdByFullName(dataJo.getString("mcmc"), farmNameEntityList));
                        workPlanEntity.setFarmName(dataJo.getString("mcmc"));
                        workPlanEntity.setPigQuantity(dataJo.getInteger("zzsl"));
                        workPlanEntity.setPlanName(dataJo.getString("jhmc"));
                        workPlanEntity.setPlanTimes(dataJo.getInteger("jhts"));
                        workPlanEntity.setAddTime(new Timestamp(new Date().getTime()));
                        workPlanRepo.save(workPlanEntity);
                    }
                }
            }
        }
    }

    @Autowired
    private ProdSowPigletStatusRepo sowPigletStatusRepo;

    @Override
    public void getPrepareStatusQuantity() throws IOException, ParseException {
        //
        Map timeoutMap = httpClientUtil.setTimeout(connectTimeout, requestTimeout, socketTimeout);
        //
        String token = getRemoteToken();
        //
        Map<String, String> paramsMap = new HashMap<String, String>();
        paramsMap.put("accessToken", token);

        String url = apiIp + apiPort + serviceName + "/getPrepareStatusQuantity";
        log.info("获取母猪和仔猪各种状态数据访问地址=" + url);
        log.info("业务请求参数=" + paramsMap.toString());
        log.info("开始取数=" + new Date(System.currentTimeMillis()));
        //
        JSONObject outJo = httpClientUtil.doGet(url, paramsMap);
        log.info("返回结果=" + outJo);
        log.info("结束取数=" + new Date(System.currentTimeMillis()));
        if (outJo.getBoolean("status")) {
            JSONObject contentJo = outJo.getJSONObject("content");
            if (contentJo.getBoolean("success")) {
                JSONArray dataJa = contentJo.getJSONArray("data");
                if (dataJa.size() == 0) {
                    log.info("未取到数据 。");
                } else {
                    //删除旧数据
                    ProdSowPigletStatusEntity delSowPigletStatusEntity = new ProdSowPigletStatusEntity();
                    delSowPigletStatusEntity.setAddDate(dateUtil.getTodayDate());
                    Example<ProdSowPigletStatusEntity> example = Example.of(delSowPigletStatusEntity);
                    sowPigletStatusRepo.deleteAll(sowPigletStatusRepo.findAll(example));
                    //获取牧场所有名称数据
                    List<ProdFarmNameEntity> farmNameEntityList = prodFarmNameRepo.findAll();
                    //获取牧场所有名称数据
                    for (int a = 0; a < dataJa.size(); a++) {
                        JSONObject dataJo = dataJa.getJSONObject(a);
                        ProdSowPigletStatusEntity sowPigletStatusEntity = new ProdSowPigletStatusEntity();
                        sowPigletStatusEntity.setFarmName(dataJo.getString("mcmc"));
                        sowPigletStatusEntity.setFarmId(_getFarmIdByShortName(dataJo.getString("mcmc"), farmNameEntityList));
                        sowPigletStatusEntity.setStatus1(dataJo.getInteger("dfm"));
                        sowPigletStatusEntity.setStatus2(dataJo.getInteger("ddn"));
                        sowPigletStatusEntity.setStatus3(dataJo.getInteger("dpz"));
                        sowPigletStatusEntity.setAddDate(new Timestamp(new Date().getTime()));
                        sowPigletStatusRepo.save(sowPigletStatusEntity);
                    }

                }
            }
        }
    }

    @Autowired
    private ProdPayableRankRepo payableRankRepo;

    @Override
    public void getPayable() throws ParseException, IOException {
        //
        Map timeoutMap = httpClientUtil.setTimeout(connectTimeout, requestTimeout, socketTimeout);
        //
        String token = getRemoteToken();
        //
        Map<String, String> paramsMap = new HashMap<String, String>();
        paramsMap.put("accessToken", token);

        String url = apiIp + apiPort + serviceName + "/getPayable";
        log.info("销售数据接口访问地址=" + url);
        log.info("业务请求参数=" + paramsMap.toString());
        log.info("开始取数=" + new Date(System.currentTimeMillis()));
        //
        JSONObject outJo = httpClientUtil.doGet(url, paramsMap);
        log.info("返回结果=" + outJo);
        log.info("结束取数=" + new Date(System.currentTimeMillis()));
        if (outJo.getBoolean("status")) {
            JSONObject contentJo = outJo.getJSONObject("content");
            if (contentJo.getBoolean("success")) {
                JSONArray dataJa = contentJo.getJSONArray("data");
                if (dataJa.size() == 0) {
                    log.info("未取到数据 。");
                } else {
                    //删除旧数据
                    ProdPayableRankEntity delPayableRankEntity = new ProdPayableRankEntity();
                    delPayableRankEntity.setAddDate(dateUtil.getTodayDate());
                    Example<ProdPayableRankEntity> example = Example.of(delPayableRankEntity);
                    payableRankRepo.deleteAll(payableRankRepo.findAll(example));

                    //获取牧场所有名称数据
                    List<ProdFarmNameEntity> farmNameEntityList = prodFarmNameRepo.findAll();
                    //获取牧场所有名称数据
                    for (int a = 0; a < dataJa.size(); a++) {
                        JSONObject dataJo = dataJa.getJSONObject(a);
                        ProdPayableRankEntity addPayableRankEntity = new ProdPayableRankEntity();
                        addPayableRankEntity.setFarmName(dataJo.getString("mcmc"));
                        //
                        addPayableRankEntity.setFarmId(_getFarmIdByShortName(dataJo.getString("mcmc"), farmNameEntityList));
                        addPayableRankEntity.setRank(dataJo.getInteger("rank"));
                        addPayableRankEntity.setMoney(dataJo.getFloat("je"));
                        addPayableRankEntity.setSupplier(dataJo.getString("supplier"));
                        addPayableRankEntity.setAddDate(new Timestamp(new Date().getTime()));
                        payableRankRepo.save(addPayableRankEntity);
                    }
                }
            }
        }
    }

    @Autowired
    private ProdSalesRepo salesRepo;

    @Override
    public void getSales() throws IOException, ParseException {

        //
        Map timeoutMap = httpClientUtil.setTimeout(connectTimeout, requestTimeout, socketTimeout);
        //
        String token = getRemoteToken();
        //
        Map<String, String> paramsMap = new HashMap<String, String>();
        paramsMap.put("accessToken", token);

        String url = apiIp + apiPort + serviceName + "/getSales";
        log.info("销售数据接口访问地址=" + url);
        log.info("业务请求参数=" + paramsMap.toString());
        log.info("开始取数=" + new Date(System.currentTimeMillis()));
        //
        JSONObject outJo = httpClientUtil.doGet(url, paramsMap);
        log.info("返回结果=" + outJo);
        log.info("结束取数=" + new Date(System.currentTimeMillis()));
        if (outJo.getBoolean("status")) {
            JSONObject contentJo = outJo.getJSONObject("content");
            if (contentJo.getBoolean("success")) {
                JSONArray dataJa = contentJo.getJSONArray("data");
                if (dataJa.size() == 0) {
                    log.info("未取到数据 。");
                } else {
                    //删除旧数据
                    ProdSalesEntity delSalesEntity = new ProdSalesEntity();
                    delSalesEntity.setAddDate(dateUtil.getTodayDate());
                    Example<ProdSalesEntity> example = Example.of(delSalesEntity);
                    salesRepo.deleteAll(salesRepo.findAll(example));

                    //获取牧场所有名称数据
                    List<ProdFarmNameEntity> farmNameEntityList = prodFarmNameRepo.findAll();
                    //获取牧场所有名称数据
                    for (int a = 0; a < dataJa.size(); a++) {
                        JSONObject dataJo = dataJa.getJSONObject(a);
                        System.out.println("dataJ>>" + dataJo);
                        ProdSalesEntity addSalesEntity = new ProdSalesEntity();
                        String farmName = dataJo.getString("farm_name");
                        addSalesEntity.setFarmName(farmName);
                        //
                        addSalesEntity.setFarmId(_getFarmIdByShortName(farmName, farmNameEntityList));
                        addSalesEntity.setTodayMoney(dataJo.getString("today_money"));
                        addSalesEntity.setTodayQuantity(dataJo.getString("today_quantity"));
                        addSalesEntity.setTodayWeight(dataJo.getString("today_weight"));
                        addSalesEntity.setWeekMoney(dataJo.getString("week_money"));
                        addSalesEntity.setWeekQuantity(dataJo.getString("week_quantity"));
                        addSalesEntity.setWeekWeight(dataJo.getString("week_weight"));
                        addSalesEntity.setMonthMoney(dataJo.getString("month_money"));
                        addSalesEntity.setMonthQuantity(dataJo.getString("month_quantity"));
                        addSalesEntity.setMonthWeight(dataJo.getString("month_weight"));
                        addSalesEntity.setAddDate(new Timestamp(new Date().getTime()));
                        salesRepo.save(addSalesEntity);
                    }
                }
            }
        }
    }

    @Override
    public void testGetManyFarmPsy() throws IOException {
        //
        Map timeoutMap = httpClientUtil.setTimeout(connectTimeout, requestTimeout, socketTimeout);
        //
        String token = getRemoteToken();
        Map<String, String> paramsMap = new HashMap<String, String>();
        paramsMap.put("accessToken", token);
        paramsMap.put("startDate", dateUtil.getStartDateInThisMonth());
        paramsMap.put("endDate", dateUtil.getEndDateInThisMonth());

        //嘉兴秀洲青莲农业科技有限公司
        System.out.println("嘉兴秀洲青莲农业科技有限公司");
        paramsMap.put("farmID", "8466682B-0B55-4139-A5BE-AC3BB1DA9A45");
        System.out.println(">>" + paramsMap);
        System.out.println("返回结果>>" + httpClientUtil.doGet(apiIp + apiPort + serviceName + "/getPsy", paramsMap));
// 空

        //海盐曙光
        System.out.println("海盐曙光");
        paramsMap.put("farmID", "31025DA4-F9E1-46B8-BF38-5F2FA25E9C07");
        System.out.println(">>" + paramsMap);
        System.out.println("返回结果>>" + httpClientUtil.doGet(apiIp + apiPort + serviceName + "/getPsy", paramsMap));
        //{"content":"{\"success\":true,\"code\":10000,\"message\":\"操作成功！\",\"data\":\"26.10\"}","status":true}

        //嘉兴青莲王江泾农业发展有限公司
        System.out.println("嘉兴青莲王江泾农业发展有限公司");
        paramsMap.put("farmID", "F7F05931-84E8-4983-89FE-5F967C35BF51");
        System.out.println(">>" + paramsMap);
        System.out.println("返回结果>>" + httpClientUtil.doGet(apiIp + apiPort + serviceName + "/getPsy", paramsMap));
        //空
        //{"content":"{\"success\":true,\"code\":10000,\"message\":\"操作成功！\",\"data\":\"\"}","status":true}

        //嘉兴青莲黑猪原种场
        System.out.println("嘉兴青莲黑猪原种场");
        paramsMap.put("farmID", "1F0F0044-715F-4854-9F57-82ED69EB21C9");
        System.out.println(">>" + paramsMap);
        System.out.println("返回结果>>" + httpClientUtil.doGet(apiIp + apiPort + serviceName + "/getPsy", paramsMap));
// 空
        //{"content":"{\"success\":true,\"code\":10000,\"message\":\"操作成功！\",\"data\":\"\"}","status":true}

        //武义本生二农业开发有限公司
        System.out.println("武义本生二农业开发有限公司");
        paramsMap.put("farmID", "49C5ECC5-3B66-4851-84B8-C2E5179ACAC5");
        System.out.println(">>" + paramsMap);
        System.out.println("返回结果>>" + httpClientUtil.doGet(apiIp + apiPort + serviceName + "/getPsy", paramsMap));
        //空
        //{"content":"{\"success\":true,\"code\":10000,\"message\":\"操作成功！\",\"data\":\"\"}","status":true}

//        //兰溪市益品生态农牧发展有限公司
        System.out.println("兰溪市益品生态农牧发展有限公司");
        paramsMap.put("farmID", "583659FD-FEAE-4684-B21B-7A1BB20210AB");
        System.out.println(">>" + paramsMap);
        System.out.println("返回结果>>" + httpClientUtil.doGet(apiIp + apiPort + serviceName + "/getPsy", paramsMap));
        //空
        //{"content":"{\"success\":true,\"code\":10000,\"message\":\"操作成功！\",\"data\":\"\"}","status":true}

        //武义本生农业开发有限公司
        System.out.println("武义本生农业开发有限公司");
        paramsMap.put("farmID", "5D8527E1-10B7-49D0-B89A-2A9D88010D31");
        System.out.println(">>" + paramsMap);
        System.out.println("返回结果>>" + httpClientUtil.doGet(apiIp + apiPort + serviceName + "/getPsy", paramsMap));
        //空
        //{"content":"{\"success\":true,\"code\":10000,\"message\":\"操作成功！\",\"data\":\"\"}","status":true}

        //浙江盼达农业科技有限公司
        System.out.println("浙江盼达农业科技有限公司");
        paramsMap.put("farmID", "C6AD1371-64C5-4CC1-B236-FCCD2E83BF08");
        System.out.println(">>" + paramsMap);
        System.out.println("返回结果>>" + httpClientUtil.doGet(apiIp + apiPort + serviceName + "/getPsy", paramsMap));
        //空
        //{"content":"{\"success\":true,\"code\":10000,\"message\":\"操作成功！\",\"data\":\"\"}","status":true}

        //浙江茶香牧业有限公司
        System.out.println("浙江茶香牧业有限公司");
        paramsMap.put("farmID", "CE8B6155-FCE2-453F-A4E6-EBBB012298F0");
        System.out.println(">>" + paramsMap);
        System.out.println("返回结果>>" + httpClientUtil.doGet(apiIp + apiPort + serviceName + "/getPsy", paramsMap));
        //空
        //{"content":"{\"success\":true,\"code\":10000,\"message\":\"操作成功！\",\"data\":\"\"}","status":true}

        //海盐海兴
        System.out.println("海盐海兴");
        paramsMap.put("farmID", "FE9D5092-0113-48AE-884B-51205B474391");
        System.out.println(">>" + paramsMap);
        System.out.println("返回结果>>" + httpClientUtil.doGet(apiIp + apiPort + serviceName + "/getPsy", paramsMap));
        //空
        //{"content":"{\"success\":true,\"code\":10000,\"message\":\"操作成功！\",\"data\":\"\"}","status":true}

        //昆山青莲梅山生猪养殖有限公司
        System.out.println("昆山青莲梅山生猪养殖有限公司");
        paramsMap.put("farmID", "48577FA9-3B7F-4974-BA1F-73026C885F62");
        System.out.println(">>" + paramsMap);
        System.out.println("返回结果>>" + httpClientUtil.doGet(apiIp + apiPort + serviceName + "/getPsy", paramsMap));
        //空
        //{"content":"{\"success\":true,\"code\":10000,\"message\":\"操作成功！\",\"data\":\"\"}","status":true}


    }

    @Override
    public void getManyFarmPsy() throws IOException, InterruptedException {
        //
        Map timeoutMap = httpClientUtil.setTimeout(connectTimeout, requestTimeout, socketTimeout);
        //
        String token = getRemoteToken();
        String year = dateUtil.getThisYear();
        String month = dateUtil.getThisMonth();

        //查询所有记录
        List<ProdFarmNameEntity> farmNameEntityList = prodFarmNameRepo.findAll();

        Map<String, String> paramsMap = new HashMap<String, String>();
        paramsMap.put("accessToken", token);

        paramsMap.put("startDate", dateUtil.getStartDateInThisMonth());
        paramsMap.put("endDate", dateUtil.getEndDateInThisMonth());


        JSONArray psyJa = new JSONArray();
        for (ProdFarmNameEntity farmNameEntity : farmNameEntityList) {
            if (null != farmNameEntity.getErpFarmId()) {
//                Thread.sleep(5000);
                //
                paramsMap.put("farmID", farmNameEntity.getErpFarmId());
                System.out.println("" + farmNameEntity.getErpFarmName() + " , " + farmNameEntity.getErpFarmId());

                String url = apiIp + apiPort + serviceName + "/getPsy";
                log.info("销售数据接口访问地址=" + url);
                log.info("业务请求参数=" + paramsMap.toString());
                log.info("开始取数=" + new Date(System.currentTimeMillis()));
                //
                JSONObject outJo = httpClientUtil.doGet(url, paramsMap);
                log.info("返回结果>>" + outJo);
                log.info("结束取数=" + new Date(System.currentTimeMillis()));
                if (outJo.getBoolean("status")) {
                    JSONObject contentJo = outJo.getJSONObject("content");
                    if (contentJo.getBoolean("success")) {
                        String psyData = contentJo.getString("data");
                        System.out.println(">>" + psyData);
                        if (null == psyData || psyData.trim().length() == 0) {
                            log.info("未取到数据 。");
                        } else {
                            System.out.println("data=" + psyData);
                            JSONObject psyJo = new JSONObject();
                            psyJa.add(psyJo);
                            psyJo.put("stock_type", "psy");
                            psyJo.put("stock_name", "PSY");
                            psyJo.put("stock_quantity", psyData);
                            psyJo.put("month", month);
                            psyJo.put("year", year);
                            psyJo.put("farm_id", farmNameEntity.getFarmId());
                            psyJo.put("farm_name", farmNameEntity.getFarmName());
                        }
                    }
                }
            }
        }
        //关闭http连接资源
//        httpClientUtil.closeHttpConn();
        System.out.println("psyJa.size=" + psyJa.size());
        if (psyJa.size() > 0) {
            //
            ProdProduceEntity delEntity = new ProdProduceEntity();
            delEntity.setYear(Integer.parseInt(year));
            delEntity.setMonth(Integer.parseInt(month));
            delEntity.setStockType("psy");
            Example<ProdProduceEntity> delExample = Example.of(delEntity);
            produceRepo.deleteAll(produceRepo.findAll(delExample));
            //
            for (int a = 0; a < psyJa.size(); a++) {
                JSONObject psyJo = psyJa.getJSONObject(a);
                ProdProduceEntity addEntity1 = new ProdProduceEntity();
                addEntity1.setFarmId(psyJo.getInteger("farm_id"));
                addEntity1.setStockType("psy");
                addEntity1.setStockName("PSY");
                addEntity1.setStockQuantity(psyJo.getString("stock_quantity"));
                addEntity1.setMonth(Integer.valueOf(month));
                addEntity1.setYear(Integer.parseInt(year));
                produceRepo.saveAndFlush(addEntity1);
            }

            ///////////////////////////////////////////////////////////////////////////////////////////////////////
            //重点指标表（试点）
            //PSY
            //计算前一个月（年、月）
            Map beforeMonthMap = dateUtil.getBeforeMonth();

            //计算涨跌和统计动态变化指标数量
            JSONArray dynamicJa = getBeforeLastMonth(psyJa, beforeMonthMap);

            //删除当前一个月的数据
            ProdImportantIndicatorEntity delImportantEntity = new ProdImportantIndicatorEntity();
            delImportantEntity.setYear(Integer.parseInt(year));
            delImportantEntity.setMonth(Integer.parseInt(month));
            delImportantEntity.setStockType("psy");
            Example<ProdImportantIndicatorEntity> delExample2 = Example.of(delImportantEntity);
            prodImportantIndicatorRepo.deleteAll(prodImportantIndicatorRepo.findAll(delExample2));
            //
            for (int a = 0; a < psyJa.size(); a++) {
                JSONObject psyJo = psyJa.getJSONObject(a);
                ProdImportantIndicatorEntity addImportantEntity1 = new ProdImportantIndicatorEntity();
                addImportantEntity1.setFarmId(psyJo.getInteger("farm_id"));
                addImportantEntity1.setStockType("psy");
                addImportantEntity1.setStockName("PSY");
                addImportantEntity1.setStockQuantity(psyJo.getString("stock_quantity"));
                addImportantEntity1.setMonth(Integer.valueOf(month));
                addImportantEntity1.setYear(Integer.parseInt(year));
                //涨跌
                addImportantEntity1.setRiseFall(psyJo.getInteger("rise_fall"));
                //幅度
                addImportantEntity1.setRange1(psyJo.getString("range"));
                prodImportantIndicatorRepo.saveAndFlush(addImportantEntity1);
            }
            //添加重要指标动态统计表
//            //删除旧数据
//            ProdIndicatorDynamicEntity delDynamicEntity = new ProdIndicatorDynamicEntity();
//            delDynamicEntity.setYear(Integer.parseInt(year));
//            delDynamicEntity.setMonth(Integer.parseInt(month));
//            Example<ProdIndicatorDynamicEntity> delExample3 = Example.of(delDynamicEntity);
//            prodIndicatorDynamicRepo.deleteAll(prodIndicatorDynamicRepo.findAll(delExample3));
//            //增加信息数据
//            for (int a = 0; a < dynamicJa.size(); a++) {
//                JSONObject dynamicJo = dynamicJa.getJSONObject(a);
//                ProdIndicatorDynamicEntity addDynamicEntity = new ProdIndicatorDynamicEntity();
//                addDynamicEntity.setFarmId(dynamicJo.getInteger("farm_id"));
//                addDynamicEntity.setYear(Integer.parseInt(year));
//                addDynamicEntity.setMonth(Integer.parseInt(month));
//                addDynamicEntity.setTotal(dynamicJo.getInteger("total"));
//                addDynamicEntity.setUp(dynamicJo.getInteger("up"));
//                addDynamicEntity.setDown(dynamicJo.getInteger("down"));
//                addDynamicEntity.setFlat(dynamicJo.getInteger("flat"));
//                prodIndicatorDynamicRepo.saveAndFlush(addDynamicEntity);
//            }
            //更新重要指标统计动态变化数量
            for (int a = 0; a < psyJa.size(); a++) {
                JSONObject psyJo = psyJa.getJSONObject(a);
                //
                updateDynamicCount(psyJo.getInteger("farm_id"), year, month);
            }
        }
    }

    //
    private JSONArray getBeforeLastMonth(JSONArray psyJa, Map beforeMonthMap) {
        String beforeMonth = beforeMonthMap.get("month").toString();
        String beforeYear = beforeMonthMap.get("year").toString();
        //查找前一个月的数据
        ProdImportantIndicatorEntity findImportantEntity = new ProdImportantIndicatorEntity();
        findImportantEntity.setYear(Integer.parseInt(beforeYear));
        findImportantEntity.setMonth(Integer.parseInt(beforeMonth));
        findImportantEntity.setStockType("psy");
        Example<ProdImportantIndicatorEntity> delExample2 = Example.of(findImportantEntity);
        List<ProdImportantIndicatorEntity> beforeImportantEntityList = prodImportantIndicatorRepo.findAll(delExample2);

        JSONArray dynamicJa = new JSONArray();
        int up = 0;
        int down = 0;
        int flat = 0;
        for (int a = 0; a < psyJa.size(); a++) {
            JSONObject psyJo = psyJa.getJSONObject(a);
            boolean isExist = false;
            for (ProdImportantIndicatorEntity beforeImportantEntity : beforeImportantEntityList) {
                if (beforeImportantEntity.getFarmId().equals(psyJo.getInteger("farm_id"))) {
                    isExist = true;
                    BigDecimal beforeQuantityBd = new BigDecimal(beforeImportantEntity.getStockQuantity());
                    BigDecimal quantityBd = new BigDecimal(psyJo.getString("stock_quantity"));
                    if (quantityBd.compareTo(beforeQuantityBd) == 0) {
                        psyJo.put("rise_fall", 1);
                        psyJo.put("range", "0");
                        flat++;
                    } else if (quantityBd.compareTo(beforeQuantityBd) == 1) {
                        psyJo.put("rise_fall", 1);
                        psyJo.put("range", quantityBd.subtract(beforeQuantityBd));
                        up++;
                    } else {
                        psyJo.put("rise_fall", 0);
                        psyJo.put("range", beforeQuantityBd.subtract(quantityBd));
                        down++;
                    }
                    break;
                }
            }
            if (!isExist) {
                psyJo.put("rise_fall", 1);
                psyJo.put("range", psyJo.getString("stock_quantity"));
                up++;
            }
            JSONObject dynamicJo = new JSONObject();
            dynamicJa.add(dynamicJo);
            dynamicJo.put("total", up + down + flat);
            dynamicJo.put("up", up);
            dynamicJo.put("down", down);
            dynamicJo.put("flat", flat);
            dynamicJo.put("farm_id", psyJo.getIntValue("farm_id"));
        }
        return dynamicJa;
    }

    @Override
    public void getManyFarmParturitionRate() throws IOException {
        //
        Map timeoutMap = httpClientUtil.setTimeout(connectTimeout, requestTimeout, socketTimeout);
        //
        String token = getRemoteToken();
        String year = dateUtil.getThisYear();
        String month = dateUtil.getThisMonth();
        //查询所有记录
        List<ProdFarmNameEntity> farmNameEntityList = prodFarmNameRepo.findAll();
        JSONArray newJa = new JSONArray();
        for (ProdFarmNameEntity farmNameEntity : farmNameEntityList) {
            if (null != farmNameEntity.getErpFarmId()) {
                //
                Map<String, String> paramsMap = new HashMap<String, String>();
                paramsMap.put("accessToken", token);
                paramsMap.put("farmName", farmNameEntity.getErpFarmName());
                paramsMap.put("startDate", dateUtil.getStartDateInThisMonth());
                paramsMap.put("endDate", dateUtil.getEndDateInThisMonth());

                String url = apiIp + apiPort + serviceName + "/getParturitionRate";
                log.info("销售数据接口访问地址=" + url);
                log.info("业务请求参数=" + paramsMap.toString());
                log.info("开始取数=" + new Date(System.currentTimeMillis()));
                //
                JSONObject outJo = httpClientUtil.doGetBatch(url, paramsMap);
//                log.info("返回结果>>" + outJo);
                log.info("结束取数=" + new Date(System.currentTimeMillis()));
                if (outJo.getBoolean("status")) {
                    JSONObject contentJo = outJo.getJSONObject("content");
                    if (contentJo.getBoolean("success")) {
                        JSONArray dataJa = contentJo.getJSONArray("data");
//                        System.out.println(""+dataJa);
                        if (null == dataJa || dataJa.size() == 0) {
                            log.info("未取到数据 。");
                        } else {
                            JSONObject dataJo = dataJa.getJSONObject(0);
                            JSONObject newJo = new JSONObject();
                            newJa.add(newJo);
                            newJo.put("stock_type", "breed_rate");
                            newJo.put("stock_name", "配种分娩率");
                            newJo.put("stock_quantity", dataJo.getString("parturition_rate"));
                            newJo.put("month", month);
                            newJo.put("year", year);
                            newJo.put("farm_id", farmNameEntity.getFarmId());
                            newJo.put("farm_name", farmNameEntity.getFarmName());
                        }
                    }
                }
            }
        }
        //关闭http连接资源
        httpClientUtil.closeHttpConn();

//        for(int a=0;a<newJa.size();a++){
//            JSONObject newJo = newJa.getJSONObject(a);
//            System.out.println(""+newJo+" __ "+mathUtil.countRate(Float.parseFloat(newJo.getString("stock_quantity")),1));
//        }
        System.out.println("newJa.size=" + newJa.size());

        if (newJa.size() > 0) {
            //
            ProdProduceEntity delEntity = new ProdProduceEntity();
            delEntity.setYear(Integer.parseInt(year));
            delEntity.setMonth(Integer.parseInt(month));
            delEntity.setStockType("breed_rate");
            Example<ProdProduceEntity> delExample = Example.of(delEntity);
            produceRepo.deleteAll(produceRepo.findAll(delExample));
            //
            for (int a = 0; a < newJa.size(); a++) {
                JSONObject newJo = newJa.getJSONObject(a);
                ProdProduceEntity addEntity1 = new ProdProduceEntity();
                addEntity1.setFarmId(newJo.getInteger("farm_id"));
                addEntity1.setStockType("breed_rate");
                addEntity1.setStockName("配种分娩率");
//                addEntity1.setStockQuantity(mathUtil.countRate(Float.parseFloat(newJo.getString("stock_quantity")),1));
                addEntity1.setStockQuantity(newJo.getString("stock_quantity"));
                addEntity1.setMonth(Integer.valueOf(month));
                addEntity1.setYear(Integer.parseInt(year));
                produceRepo.saveAndFlush(addEntity1);
            }
        }
    }


   /* public static void main(String[] args) {
        RestTemplate restTemplate = new RestTemplate();


        JSONObject token1 = restTemplate.getForObject("http://192.168.1.62:9100/token/getToken?userId=20210501&timestamp=45546546454&random=1156&sign=7fa431325504e01e9fa87ed0e274c40c",
                JSONObject.class);
       String token =  token1.getString("accessToken");
        JSONObject jsonObject = restTemplate.getForObject("http://192.168.1.62:9100/erpData/getReEstrusRate?startDate=2020.1.1&endDate=2021.12.31&accessToken="+token
                ,JSONObject.class );
        String data = jsonObject.getString("data");
        String reestrus_rate ="0.00000";
       List<Map<String,String>> list =  (List<Map<String,String>> ) JSON.parse(data);
        for (Map<String, String> stringStringMap : list) {
            for (String s : stringStringMap.keySet()) {
                String farm = stringStringMap.get(s);
                //                if (farm != null && farm.contains("秀洲")){
                    reestrus_rate  = stringStringMap.get("reestrus_rate");
                }
            }
        }



    }*/
}
