package com.huimv.production.autoGetData.utils;

import com.alibaba.fastjson.JSONObject;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
@SpringBootTest
public class HttpTempleteTest {
    @Autowired
    private HttpTemplete httpTemplete;
    //本地测试地址
    String testLocalHttpIp = "http://localhost:9100";
    //远程测试地址
    String testRemoteHttpIp = "http://121.40.221.149:9100";

    //### 推送接口使用说明 ###
    //1.服务端先要提供接收端口（ip地址+接口访问路径）
    //2.用httpTemplete模板类用Post或Get方式进行数据推送

    //用Post方法推送接口数据--示例
    @Test
    public void testPost() throws IOException {
        String url = testLocalHttpIp + "/demo/saveDemo";
        System.out.println("测试推送地址："+url);
        //
        Map<String,String> paramsMap = new HashMap<String,String>();
        paramsMap.put("name", "tony");
        paramsMap.put("age", "25");
        paramsMap.put("no", "1156");
        //
        Map<String,Integer> timeoutMap = new HashMap<String,Integer>();
        timeoutMap.put("connectTimeout", 5000);
        timeoutMap.put("requestTimeout", 5000);
        timeoutMap.put("socketTimeout", 5000);
        // 用Post方法推送接口数据
        JSONObject outJo = httpTemplete.doPost(url,paramsMap,timeoutMap);
        System.out.println("测试结果="+outJo);
    }

    //用Get方法推送接口数据--示例
    @Test
    public void testGet() throws IOException {
        Map<String, String> paramsMap = new HashMap<String, String>();
        paramsMap.put("userId", "20210501");
        paramsMap.put("timestamp", "45546546454");
        paramsMap.put("random", "1156");
        paramsMap.put("sign", "7fa431325504e01e9fa87ed0e274c40c");

        Map<String, Integer> timeoutMap = new HashMap<String, Integer>();
        timeoutMap.put("connectTimeout", 5000);
        timeoutMap.put("requestTimeout", 5000);
        timeoutMap.put("socketTimeout", 5000);

        String url = testRemoteHttpIp + "/token/getToken";
        //用Get方法推送接口数据
        JSONObject resultJo = httpTemplete.doGet(url, paramsMap, timeoutMap);
        System.out.println("status=" + resultJo.getBoolean("status"));
        System.out.println("content=" + resultJo.getJSONObject("content"));
    }
}
